Name:		python-ipyparallel
Version:	6.0.2
Release:	2%{?dist}
Summary:	Interactive Parallel Computing with IPython

License:	BSD
URL:		https://github.com/ipython/ipyparallel
Source0:	https://github.com/ipython/ipyparallel/archive/%{version}.tar.gz
#		Test updates (backported)
#		https://github.com/ipython/ipyparallel/pull/254
Patch0:		%{name}-pr254.patch

BuildArch:	noarch
BuildRequires:	python2-devel
BuildRequires:	python3-devel
BuildRequires:	python2-ipython_genutils
BuildRequires:	python3-ipython_genutils
BuildRequires:	python2-decorator
BuildRequires:	python3-decorator
BuildRequires:	python2-zmq >= 13
BuildRequires:	python3-zmq >= 13
BuildRequires:	python2-ipython >= 4
BuildRequires:	python3-ipython >= 4
BuildRequires:	python2-jupyter-client
BuildRequires:	python3-jupyter-client
BuildRequires:	python2-ipykernel
BuildRequires:	python3-ipykernel
BuildRequires:	python2-tornado >= 4
BuildRequires:	python3-tornado >= 4
BuildRequires:	python2-dateutil >= 2.1
BuildRequires:	python3-dateutil >= 2.1
BuildRequires:	python2-futures
#		For testing:
BuildRequires:	python2-pytest
BuildRequires:	python3-pytest
BuildRequires:	python2-zmq-tests
BuildRequires:	python3-zmq-tests
BuildRequires:	python2-mock
#		IPython.testing.decorators uses numpy's decorators
BuildRequires:	python2-numpy
BuildRequires:	python3-numpy
#		Dependency of numpy.testing.noseclasses
BuildRequires:	python2-nose
BuildRequires:	python3-nose
#		For documentation
BuildRequires:	python3-sphinx
BuildRequires:	python3-ipython-sphinx

%description
ipyparallel is the new home of IPython.parallel. ipyparallel is a
Python package and collection of CLI scripts for controlling clusters
for Jupyter.

%package -n python2-ipyparallel
Summary:	Interactive Parallel Computing with IPython
%{?python_provide:%python_provide python2-ipyparallel}
Requires:	python2-ipython_genutils
Requires:	python2-decorator
Requires:	python2-zmq >= 13
Requires:	python2-ipython >= 4
Requires:	python2-jupyter-client
Requires:	python2-ipykernel
Requires:	python2-tornado >= 4
Requires:	python2-dateutil >= 2.1
Requires:	python2-futures

%description -n python2-ipyparallel
ipyparallel is the new home of IPython.parallel. ipyparallel is a
Python package and collection of CLI scripts for controlling clusters
for Jupyter.

%package -n python3-ipyparallel
Summary:	Interactive Parallel Computing with IPython
%{?python_provide:%python_provide python3-ipyparallel}
Requires:	python3-ipython_genutils
Requires:	python3-decorator
Requires:	python3-zmq >= 13
Requires:	python3-ipython >= 4
Requires:	python3-jupyter-client
Requires:	python3-ipykernel
Requires:	python3-tornado >= 4
Requires:	python3-dateutil >= 2.1

%description -n python3-ipyparallel
ipyparallel is the new home of IPython.parallel. ipyparallel is a
Python package and collection of CLI scripts for controlling clusters
for Jupyter.

%package -n python2-ipyparallel-tests
Summary:	Tests for python2-ipyparallel
%{?python_provide:%python_provide python2-ipyparallel-tests}
Requires:	python2-ipyparallel = %{version}-%{release}
Requires:	python2-pytest
Requires:	python2-zmq-tests
Requires:	python2-mock
Requires:	python2-numpy
Requires:	python2-nose

%description -n python2-ipyparallel-tests
This package contains the tests of python2-ipyparallel.

%package -n python3-ipyparallel-tests
Summary:	Tests for python3-ipyparallel
%{?python_provide:%python_provide python3-ipyparallel-tests}
Requires:	python3-ipyparallel = %{version}-%{release}
Requires:	python3-pytest
Requires:	python3-zmq-tests
Requires:	python3-numpy
Requires:	python3-nose

%description -n python3-ipyparallel-tests
This package contains the tests of python3-ipyparallel.

%package -n python2-ipyparallel-doc
Summary:	Documentation for python2-ipyparallel
%{?python_provide:%python_provide python2-ipyparallel-doc}

%description -n python2-ipyparallel-doc
This package contains the documentation of python2-ipyparallel.

%package -n python3-ipyparallel-doc
Summary:	Documentation for python3-ipyparallel
%{?python_provide:%python_provide python3-ipyparallel-doc}

%description -n python3-ipyparallel-doc
This package contains the documentation of python3-ipyparallel.

%prep
%setup -q -n ipyparallel-%{version}
%patch0 -p1

%build
%py2_build
%py3_build

pushd docs
PYTHONPATH=.. make html SPHINXBUILD=sphinx-build-3
rm -f build/html/.buildinfo
popd

%install
%py3_install
for f in ipcluster ipcontroller ipengine; do
  mv %{buildroot}%{_bindir}/${f} %{buildroot}%{_bindir}/${f}-%{python3_version}
  ln -s ${f}-%{python3_version} %{buildroot}%{_bindir}/${f}-3
done

%py2_install
for f in ipcluster ipcontroller ipengine; do
  mv %{buildroot}%{_bindir}/${f} %{buildroot}%{_bindir}/${f}-%{python2_version}
  ln -s ${f}-%{python2_version} %{buildroot}%{_bindir}/${f}-2
  ln -s ${f}-%{python2_version} %{buildroot}%{_bindir}/${f}
done

for f in apps/ipclusterapp.py apps/ipcontrollerapp.py apps/ipengineapp.py \
	 apps/iploggerapp.py controller/heartmonitor.py; do
  sed '/\/usr\/bin\/env/d' -i %{buildroot}%{python2_sitelib}/ipyparallel/${f}
  sed '/\/usr\/bin\/env/d' -i %{buildroot}%{python3_sitelib}/ipyparallel/${f}
done

%check
pytest-2 -vs ipyparallel/tests
pytest-3 -vs ipyparallel/tests

%files -n python2-ipyparallel
%license COPYING.md
%doc README.md
%{python2_sitelib}/ipyparallel-*.egg-info
%dir %{python2_sitelib}/ipyparallel
%{python2_sitelib}/ipyparallel/*.py*
%{python2_sitelib}/ipyparallel/apps
%{python2_sitelib}/ipyparallel/client
%{python2_sitelib}/ipyparallel/controller
%{python2_sitelib}/ipyparallel/engine
%{python2_sitelib}/ipyparallel/nbextension
%{python2_sitelib}/ipyparallel/serialize
%{_bindir}/ipcluster
%{_bindir}/ipcluster-2
%{_bindir}/ipcluster-%{python2_version}
%{_bindir}/ipcontroller
%{_bindir}/ipcontroller-2
%{_bindir}/ipcontroller-%{python2_version}
%{_bindir}/ipengine
%{_bindir}/ipengine-2
%{_bindir}/ipengine-%{python2_version}

%files -n python3-ipyparallel
%license COPYING.md
%doc README.md
%{python3_sitelib}/ipyparallel-*.egg-info
%dir %{python3_sitelib}/ipyparallel
%{python3_sitelib}/ipyparallel/*.py
%{python3_sitelib}/ipyparallel/__pycache__
%{python3_sitelib}/ipyparallel/apps
%{python3_sitelib}/ipyparallel/client
%{python3_sitelib}/ipyparallel/controller
%{python3_sitelib}/ipyparallel/engine
%{python3_sitelib}/ipyparallel/nbextension
%{python3_sitelib}/ipyparallel/serialize
%{_bindir}/ipcluster-3
%{_bindir}/ipcluster-%{python3_version}
%{_bindir}/ipcontroller-3
%{_bindir}/ipcontroller-%{python3_version}
%{_bindir}/ipengine-3
%{_bindir}/ipengine-%{python3_version}

%files -n python2-ipyparallel-tests
%{python2_sitelib}/ipyparallel/tests

%files -n python3-ipyparallel-tests
%{python3_sitelib}/ipyparallel/tests

%files -n python2-ipyparallel-doc
%license COPYING.md
%doc docs/build/html

%files -n python3-ipyparallel-doc
%license COPYING.md
%doc docs/build/html

%changelog
* Thu May 18 2017 Mattias Ellert <mattias.ellert@physics.uu.se> - 6.0.2-2
- Put tests in a separate subpackage

* Sun Apr 30 2017 Mattias Ellert <mattias.ellert@physics.uu.se> - 6.0.2-1
- Initial packaging
